####TEST TIMES IT TAKES ANNOTATIONBUSTR TO EXTRACT A CERTAIN NUMBER OF SEQUENCES####

library(AnnotationBustR)
setwd("C:/Users/Sam/Desktop/AnnotationBustR/AnnotationBustR_Manuscript/Performance/Supplements/")
####TEST CP DNA#####
data("cpDNAterms")
cp.terms.to.find<-c("rbcL","matK","ndhF","atpB","rpoC1","rpoC2","rpl16","rpoB","ycf1","petB","petD","psbA","psbB")
unique.cp.loci<-subset(cpDNAterms,cpDNAterms$Locus %in%cp.terms.to.find)#Unique cpDNA terms
unique.cp.terms<-as.vector(unique(unique.cp.loci$Locus))
cp.taxa.access<-read.table("cp_taxa.txt")#read in angiosperm chloroplast accessions
set.seed(1357)#set seed for repeatability
cp.taxa<-sample(cp.taxa.access$V1, 100, replace = FALSE)#select out 100 random accessions
cp.taxa<-as.vector(cp.taxa)#make a vector

cp.check.table<-data.frame(data.frame(matrix(NA, nrow = length(cp.taxa), ncol = 14)))
cp.Time.Table<-data.frame(data.frame(matrix(NA, nrow = length(cp.taxa), ncol = 14)))#make empty time table
colnames(cp.Time.Table)<-c("Accession",1:13)#name columns for accession and number of loci

for (cp.taxa.index in 1:length(cp.taxa)){#for each taxa
  cp.Time.Table$Accession[cp.taxa.index]<-cp.taxa[cp.taxa.index]#write in accession
  for (cp.number.index in 1:length(unique.cp.terms)){#for each loci number
    if(cp.number.index<13){#if it is less than whole 13
      print(paste("Taxa number", cp.taxa.index, "N genes=", cp.number.index))#print the current info to see progress
      current.numb<-unique.cp.loci[which(unique.cp.loci$Locus%in%unique.cp.terms[1:cp.number.index]),]#subset
      tested.time<-system.time(AnnotationBust(Accessions=cp.taxa[cp.taxa.index],Terms=current.numb))#test and get time
      cp.Time.Table[cp.taxa.index,cp.number.index+1]<-tested.time[3]#write elapsed time to timetable
    }else{#get full run and check found
      print(paste("Taxa number", cp.taxa.index, "N genes=", cp.number.index))
      numb.13<-system.time(check.found<-AnnotationBust(Accession=cp.taxa[cp.taxa.index], Terms=unique.cp.loci))
      cp.Time.Table[cp.taxa.index,14]<-numb.13[3]
      cp.check.table[cp.taxa.index,]<-check.found
    }
  }
}

####TEST Mito DNA####

data("mtDNAterms")
unique.mt.loci<-subset(mtDNAterms,mtDNAterms$Type=="CDS")#Unique mitogenome terms
unique.mt.terms<-as.vector(unique(unique.mt.loci$Locus))
mt.taxa.access<-read.table("mt_taxa.txt")#read in metazoa accessions that have d-loop
cleaned.taxa<-subset(mt.taxa.access, grepl("NC",mt.taxa.access$V1)==FALSE)#subset non-refseq numbers for analysis
set.seed(2468)#set seed for repeatability
mt.taxa<-sample(cleaned.taxa$V1, 100, replace = FALSE)#select out 100 random accessions
mt.taxa<-as.vector(mt.taxa)#make a vector

mt.check.table<-data.frame(data.frame(matrix(NA, nrow = length(mt.taxa), ncol = 14)))
mt.Time.Table<-data.frame(data.frame(matrix(NA, nrow = length(mt.taxa), ncol = 14)))#make empty time table
colnames(mt.Time.Table)<-c("Accession",1:13)#name columns for accession and number of loci

for (mt.taxa.index in 1:length(mt.taxa)){#for each taxa
  mt.Time.Table$Accession[mt.taxa.index]<-mt.taxa[mt.taxa.index]#write in accession
  for (mt.number.index in 1:length(unique.mt.terms)){#for each loci number
    if(mt.number.index<13){#if it is less than whole 13
      print(paste("Taxa number", mt.taxa.index, "N genes=", mt.number.index))
      current.numb<-mtDNAterms[which(mtDNAterms$Locus%in%unique.mt.terms[1:mt.number.index]),]#subset
      tested.time<-system.time(AnnotationBust(Accessions=mt.taxa[mt.taxa.index],Terms=current.numb))#test and get time
      mt.Time.Table[mt.taxa.index,mt.number.index+1]<-tested.time[3]#write elapsed time to timetable
    }else{#else, run whole mtDNAterms
      print(paste("Taxa number", mt.taxa.index, "N genes=", mt.number.index))
      numb.13<-system.time(check.found<-AnnotationBust(Accession=mt.taxa[mt.taxa.index], Terms=unique.mt.loci))
      mt.Time.Table[mt.taxa.index,14]<-numb.13[3]
      mt.check.table[mt.taxa.index,]<-check.found
    }
  }
}

####TEST rDNA####
data("rDNAterms")
unique.rDNA.terms<-as.vector(unique(rDNAterms$Locus))#Unique rDNA terms
rDNA.taxa.access<-read.table("rDNA_taxa.txt")#read in metazoa accessions for rDNA
set.seed(12345)
rDNA.taxa<-sample(rDNA.taxa.access$V1, 100, replace = FALSE)#select out 100 random accessions
rDNA.taxa<-as.vector(rDNA.taxa)#make a vector

rDNA.check.table<-data.frame(data.frame(matrix(NA, nrow = length(rDNA.taxa), ncol = 6)))
rDNA.Time.Table<-data.frame(data.frame(matrix(NA, nrow = length(rDNA.taxa), ncol = 6)))#make empty time table
colnames(rDNA.Time.Table)<-c("Accession",1:5)#name columns for accession and number of loci

for (rDNA.taxa.index in 1:100){#for each taxa
  rDNA.Time.Table$Accession[rDNA.taxa.index]<-rDNA.taxa[rDNA.taxa.index]#write in accession
  for (rDNA.number.index in 1:length(unique.rDNA.terms)){#for each loci number
    if(rDNA.number.index<5){#if it is less than whole 5
      print(paste("Taxa number", rDNA.taxa.index, "N genes=", rDNA.number.index))
      current.numb<-rDNAterms[which(rDNAterms$Locus%in%unique.rDNA.terms[1:rDNA.number.index]),]#subset
      tested.time<-system.time(AnnotationBust(Accessions=rDNA.taxa[rDNA.taxa.index],Terms=current.numb))#test and get time
      rDNA.Time.Table[rDNA.taxa.index,rDNA.number.index+1]<-tested.time[3]#write elapsed time to timetable
    }else{#else, run whole rDNAterms
      rDNA.full<-system.time(check.found<-AnnotationBust(Accession=rDNA.taxa[rDNA.taxa.index], Terms=rDNAterms))
      rDNA.Time.Table[rDNA.taxa.index,6]<-rDNA.full[3]
      rDNA.check.table[rDNA.taxa.index,]<-check.found
    }
  }
}

#Results
write.csv(mt.Time.Table,"mtTimes.csv")
write.csv(cp.Time.Table,"cpTimes.csv")
write.csv(rDNA.Time.Table,"rDNATimes.csv")

#####GENERATE RESULTS######
library(matrixStats)
library(Hmisc)
par(mar = c(5, 4, 1.4, 8), xpd=TRUE)

#calc the avg and sdev for each timing set
mt.avg<-colMeans(mt.Time.Table[,2:14])
mt.sdev<-colSds(as.matrix(mt.Time.Table[,2:14]))
cp.avg<-colMeans(cp.Time.Table[,2:14])
cp.sdev<-colSds(as.matrix(cp.Time.Table[,2:14]))
rd.avg<-colMeans(rDNA.Time.Table[,2:6])
rd.sdev<-colSds(as.matrix(rDNA.Time.Table[,2:6]))

#Make the figures
plot(1:13, mt.avg, ylim=range(c(11, 23)),pch=16,xlim = c(1,13), xlab="Number of Loci Extracted", ylab="Time (s)", frame.plot = FALSE)
arrows(1:13, mt.avg-mt.sdev, 1:13, mt.avg+mt.sdev, length=0.05, angle=90, code=3)
points(.8:12.8, cp.avg, pch=16, col="springgreen3")
arrows(.8:12.8, cp.avg-cp.sdev, .8:12.8, cp.avg+cp.sdev, length=0.05, angle=90, code=3, col="springgreen3")
points(1.2:5.2, rd.avg, pch=16, col="purple")
arrows(1.2:5.2, rd.avg-rd.sdev, 1.2:5.2, rd.avg+rd.sdev, length=0.05, angle=90, code=3, col="purple")
minor.tick(ny=10)
axis(side = 2, at = seq(11, 23, by = 1), labels = T)
axis(side = 1, at = seq(1, 13, by = 2), labels = T)
legend("topright", legend = c("mtDNA","cpDNA","rDNA"), col = c("black","springgreen3","purple"), pch=16, cex=1.1, bty='n', title = "Sequence Type",inset=c(-.25,0))

#CHECK RAM USAGE#
peakRAM::peakRAM(AnnotationBust(Accession=cp.taxa, Terms=unique.cp.loci))
